--  v1.2
macroScript waRp_CtrlMtls
category:"waRp Tools" 
buttonText:"Control Materials"
tooltip:"Control Materials"
(
	rollout CtrlMtls "Control Materials" width:255 height:245
	(
		checkbox chk_diffuse "" pos:[154,30] width:15 height:15
		checkbox diffuse_on "" pos:[75,30] width:15 height:15
		spinner spn_Diffuse "" pos:[97,29] width:45 height:16 range:[-1,1,0]
		label lbl_Diffuse "Diffuse" pos:[12,31] width:49 height:13
		checkbox chk_bump "" pos:[154,48] width:15 height:15
		checkbox bump_on "" pos:[75,48] width:15 height:15
		spinner spn_bump "" pos:[97,47] width:45 height:16 range:[-999,999,30]
		label lbl_Bump "Bump" pos:[12,48] width:49 height:13
		checkbox chk_rough "" pos:[154,67] width:15 height:15
		checkbox rough_on "" pos:[75,67] width:15 height:15
		spinner spn_rough "" pos:[97,66] width:45 height:16 range:[-1,1,0]
		label lbl_rough "Roughness" pos:[12,67] width:60 height:13
		checkbox chk_refl "" pos:[154,87] width:15 height:15
		checkbox refl_on "" pos:[75,87] width:15 height:15
		spinner spn_Refl "" pos:[97,86] width:45 height:16 range:[-1,1,0]
		label lbl_Refl "Reflection" pos:[12,87] width:49 height:13
		checkbox chk_reflGloss "" pos:[154,126] width:15 height:15
		checkbox reflGloss_on "" pos:[75,126] width:15 height:15
		spinner spn_reflGloss "" pos:[97,125] width:45 height:16 range:[-1,1,0]
		label lbl_ReflGloss "RGlossiness" pos:[12,125] width:61 height:13
		checkbox chk_HighGloss "" pos:[154,107] width:15 height:15
		checkbox HighGloss_on "" pos:[75,107] width:15 height:15
		spinner spn_HighGloss "" pos:[97,106] width:45 height:16 range:[-1,1,0]
		label lbl_highGloss "HGlossiness" pos:[12,106] width:60 height:13
		checkbox chk_refr "" pos:[154,145] width:15 height:15
		checkbox refr_on "" pos:[75,145] width:15 height:15
		spinner spn_refr "" pos:[97,144] width:45 height:16 range:[-1,1,0]
		label lbl_refr "Refraction" pos:[12,146] width:49 height:13
		checkbox chk_refrGloss "" pos:[154,164] width:15 height:15
		checkbox refrGloss_on "" pos:[75,164] width:15 height:15
		spinner spn_refrGloss "" pos:[97,163] width:45 height:16 range:[-1,1,0]
		label lbl_refrGloss "Glossiness" pos:[12,165] width:49 height:13
		checkbox chk_Opacity "" pos:[154,184] width:15 height:15
		checkbox Opacity_on "" pos:[75,184] width:15 height:15
		spinner spn_Opacity "" pos:[97,183] width:45 height:16 range:[-1,1,0]
		label lbl_Opacity "Opacity" pos:[12,184] width:60 height:13
		label lbl_offset "Offset" pos:[103,10] width:31 height:15
		label lbl_On "On" pos:[75,10] width:15 height:15
		label lbl_invert "Invert" pos:[147,10] width:31 height:15
		radioButtons rb_VP "" pos:[200,31] width:23 height:144 labels:#("", "", "", "", "", "", "", "", "") offsets:#([0,0], [0,2], [0,6], [0,11],[0,16], [0,21], [0,26], [0,30],[0,34]) columns:1
		label lbl_VP "Show in VP" pos:[190,10] width:62 height:15
		checkButton ckb_L "L" pos:[174,107] width:17 height:17 checked:true toolTip:"Lock HilightGlossiness with ReflectionGlossiness"
		checkButton ckb_VP "show in viewport" pos:[195,207] width:24 height:24 checked:true images: #("ShowMtl.bmp",undefined,1,1,1,1,1)

		-- define a variable for all scenematerials
		local filteredScMtls = #()
		
		fn refreshVP = 
		(
			with redraw off
			(
				for mtl in filteredScMtls do 
				(
					case rb_VP.state of 
					(
						1: if lbl_diffuse.enabled == true then showTextureMap mtl mtl.texmap_diffuse on 
						2: if lbl_bump.enabled == true then showTextureMap mtl mtl.texmap_bump on 
						3: if lbl_rough.enabled == true then showTextureMap mtl mtl.texmap_roughness on 
						4: if lbl_refl.enabled == true then showTextureMap mtl mtl.texmap_reflection on 
						5: if lbl_highgloss.enabled == true then showTextureMap mtl mtl.texmap_hilightGlossiness on 
						6: if lbl_reflGloss.enabled == true then showTextureMap mtl mtl.texmap_reflectionGlossiness on 
						7: if lbl_refr.enabled == true then showTextureMap mtl mtl.texmap_refraction on 
						8: if lbl_refrGloss.enabled == true then showTextureMap mtl mtl.texmap_refractionGlossiness on
						9: if lbl_opacity.enabled == true then showTextureMap mtl mtl.texmap_Opacity on
						default: (showTextureMap mtl off ;	showTextureMap mtl on)
					)
				)
			)
		)

		
		on CtrlMtls open do
		(
			-- za enable/disable
			filteredScMtls = for i in scenematerials where (refs.dependentNodes i firstOnly:on != undefined) and ((findstring i.name  "_tg" != undefined)) collect i -- filter scenematerials, because it updates itself in a fixed intervals
					
			mat = for mtl in filteredScMtls collect mtl
			
			if mat.count > 0 then
			(
				-- initialize Lock on highGloss and reflGloss
				if mat[1].reflection_lockGlossiness == false then
					ckb_L.state = false
		
				-- disable diffuse
				if mat[1].texmap_diffuse == undefined then
				(
					lbl_diffuse.enabled=false
					spn_diffuse.enabled=false
					chk_diffuse.enabled=false
					diffuse_on.enabled=false
				)
				else  -- get their values
				(
					spn_diffuse.value = mat[1].texmap_diffuse.output.rgb_offset
					chk_diffuse.state = mat[1].texmap_diffuse.output.invert
					diffuse_on.state = mat[1].texmap_diffuse_on
				)
				
				-- disable bump
				if mat[1].texmap_bump == undefined then
				(
					lbl_bump.enabled=false
					spn_bump.enabled=false
					chk_bump.enabled=false
					bump_on.enabled=false
				)
				else  -- get their values
				(
					spn_bump.value = mat[1].texmap_bump_multiplier
					chk_bump.state = mat[1].texmap_bump.output.invert
					bump_on.state = mat[1].texmap_bump_on
				)
				
				-- disable roughness
				if mat[1].texmap_roughness == undefined then
				(
					lbl_rough.enabled=false
					spn_rough.enabled=false
					chk_rough.enabled=false
					rough_on.enabled=false
				)
				else  -- get their values
				(
					spn_rough.value = mat[1].texmap_roughness.output.rgb_offset
					chk_rough.state = mat[1].texmap_roughness.output.invert
					rough_on.state = mat[1].texmap_roughness_on
				)
				
				-- disable reflection
				if mat[1].texmap_reflection == undefined then
				(
					lbl_refl.enabled=false
					spn_refl.enabled=false
					chk_refl.enabled=false
					refl_on.enabled=false
				)
				else  -- get their values
				(
					spn_refl.value = mat[1].texmap_reflection.output.rgb_offset
					chk_refl.state = mat[1].texmap_reflection.output.invert
					refl_on.state = mat[1].texmap_reflection_on
				)
				
				-- disable high glossiness
				if mat[1].texmap_hilightGlossiness == undefined then
				(
					lbl_highgloss.enabled=false
					spn_highgloss.enabled=false
					chk_HighGloss.enabled=false
					HighGloss_on.enabled=false
				)
				else  -- get their values
				(
					spn_highGloss.value = mat[1].texmap_hilightGlossiness.output.rgb_offset
					chk_highGloss.state = mat[1].texmap_hilightGlossiness.output.invert
					highGloss_on.state = mat[1].texmap_hilightGlossiness_on
				)
				
				-- disable reflection glossiness
				if mat[1].texmap_reflectionGlossiness == undefined then
				(
					lbl_reflgloss.enabled=false
					spn_reflgloss.enabled=false
					chk_reflGloss.enabled=false
					reflGloss_on.enabled=false
				)
				else  -- get their values
				(	
					spn_reflGloss.value = mat[1].texmap_reflectionGlossiness.output.rgb_offset
					chk_reflGloss.state = mat[1].texmap_reflectionGlossiness.output.invert
					reflGloss_on.state = mat[1].texmap_reflectionGlossiness_on
				)
				
				-- disable refract
				if mat[1].texmap_refraction == undefined then
				(
					lbl_refr.enabled=false
					spn_refr.enabled=false
					chk_refr.enabled=false
					refr_on.enabled=false
				)
				else  -- get their values
				(
					spn_refr.value = mat[1].texmap_refraction.output.rgb_offset
					chk_refr.state = mat[1].texmap_reflectionGlossiness.output.invert
					refr_on.state = mat[1].texmap_reflectionGlossiness_on
				)
				
				-- disable refract glossiness
				if mat[1].texmap_refractionGlossiness == undefined then
				(
					lbl_refrgloss.enabled=false
					spn_refrgloss.enabled=false
					chk_refrGloss.enabled=false
					refrGloss_on.enabled=false
				)
				else  -- get their values
				(
					spn_refrGloss.value = mat[1].texmap_refractionGlossiness.output.rgb_offset
					chk_refrGloss.state = mat[1].texmap_refractionGlossiness.output.invert
					refrGloss_on.state = mat[1].texmap_refractionGlossiness_on
				)
				
				-- disable Opacity
				if mat[1].texmap_Opacity == undefined then
				(
					lbl_Opacity.enabled=false
					spn_Opacity.enabled=false
					chk_Opacity.enabled=false
					Opacity_on.enabled=false
				)
				else  -- get their values
				(
					spn_Opacity.value = mat[1].texmap_Opacity.output.rgb_offset
					chk_Opacity.state = mat[1].texmap_Opacity.output.invert
					Opacity_on.state = mat[1].texmap_Opacity_on
				)
				
			)
			
		)
		
		on ckb_VP changed OnOff do
		(
			if OnOff == false then
			(
				rb_VP.enabled = false
				rb_VP.state = 0
				lbl_VP.enabled = false
				refreshVP()
			)
			else
			(
				rb_VP.enabled = true
				rb_VP.state = 1
				lbl_VP.enabled = true
				refreshVP()
			)
		)
		
		on rb_VP changed chg do
		(
			refreshVP()
		)
		
		on ckb_VP rightclick do
		(
			with redraw off
			(
				if ckb_VP.state == false do
				(
					for mtl in filteredScMtls do 
					(
						showTextureMap mtl on 
						showTextureMap mtl off
					)
				)
			)
		)
		
		-- Lock HighlightGlossiness with reflectionGlossiness
		on ckb_L changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.reflection_lockGlossiness = OnOff
		)
		
		--==========================  OFFSET  =================================--
		on spn_diffuse entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_diffuse.output.rgb_offset = spn_diffuse.value
		)
		
		on spn_bump entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_bump_multiplier = spn_bump.value
		)
		
		on spn_rough entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_roughness.output.rgb_offset = spn_rough.value
		)
		
		on spn_refl entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_reflection.output.rgb_offset = spn_refl.value
		)
		
		on spn_highGloss entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_hilightGlossiness.output.rgb_offset = spn_highgloss.value
		)
		
		on spn_reflGloss entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_reflectionGlossiness.output.rgb_offset = spn_reflgloss.value
		)
		
		on spn_refr entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_refraction.output.rgb_offset = spn_refr.value
		)
		
		on spn_refrGloss entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_refractionGlossiness.output.rgb_offset = spn_refrgloss.value
		)
		
		on spn_Opacity entered do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_Opacity.output.rgb_offset = spn_opacity.value
		)
		--==========================  // OFFSET  =================================--
		
		
		--==============================  INVERT  =================================--
		on chk_Diffuse changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_diffuse.output.invert = chk_diffuse.state
		)
		
		on chk_bump changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_bump.output.invert = chk_bump.state
		)
		
		on chk_rough changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_roughness.output.invert = chk_rough.state
		)
		
		on chk_refl changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_reflection.output.invert = chk_refl.state
		)
		
		on chk_highgloss changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_hilightGlossiness.output.invert = chk_highgloss.state
		)
		
		on chk_reflGloss changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_reflectionGlossiness.output.invert = chk_reflgloss.state
		)
		
		on chk_refr changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_refraction.output.invert = chk_refr.state
		)
		
		on chk_refrGloss changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_refractionGlossiness.output.invert = chk_refrgloss.state
		)
		
		on chk_Opacity changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_Opacity.output.invert = chk_opacity.state
		)
		--============================= // INVERT  =================================--
		
		
		--================================  ON  =====================================--
		on Diffuse_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_diffuse_on = OnOff
		)
		
		on bump_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_bump_on = OnOff
		)
		
		on rough_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_roughness_on= OnOff
		)
		
		on refl_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_reflection_on = OnOff
		)
		
		on highgloss_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_hilightGlossiness_on = OnOff
		)
		
		on reflGloss_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_reflectionGlossiness_on = OnOff
		)
		
		on refr_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_refraction_on = OnOff
		)

		on refrGloss_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_refractionGlossiness_on = OnOff
		)
		
		on Opacity_on changed OnOff do
		(
			for mtl in filteredScMtls do 
				mtl.texmap_Opacity_on = OnOff
		)
		--=============================== // ON  =================================--
			
	)

	on execute do
		createdialog CtrlMtls
)